// ModifyMemoryDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ModifyMemory.h"
#include "ModifyMemoryDlg.h"

#include "SelectProcessDlg.h"
#include <atlconv.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <typeinfo> 

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CModifyMemoryDlg dialog

CModifyMemoryDlg::CModifyMemoryDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CModifyMemoryDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CModifyMemoryDlg)
	m_strAddress = _T("");
	m_strModify = _T("");
	m_strSearchMax = _T("");
	m_strSearchMin = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CModifyMemoryDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CModifyMemoryDlg)
	DDX_Control(pDX, IDC_CHECK_UNICODE, m_btnUnicode);
	DDX_Control(pDX, IDC_COMBO_SEARCH_MODE, m_comboxSearchMode);
	DDX_Control(pDX, IDC_COMBO_SEARCH_TYPE, m_comboxSearchType);
	DDX_Control(pDX, IDC_BUTTON_INPORT_FILE, m_btnInportFile);
	DDX_Control(pDX, IDC_BUTTON_EXPORT_SELECT, m_btnExportSelect);
	DDX_Control(pDX, IDC_BUTTON_RESELECT, m_btnReSelectProcess);
	DDX_Control(pDX, IDC_BUTTON_ADD, m_btnAdd);
	DDX_Control(pDX, IDC_BUTTON_REFRESH, m_btnRefresh);
	DDX_Control(pDX, IDC_BUTTON_CANCEL_SELECT, m_btnCancelSelect);
	DDX_Control(pDX, IDC_BUTTON_MODIFY_NUMBER, m_btnModifyNumber);
	DDX_Control(pDX, IDC_BUTTON_SELECT_ALL, m_btnSelectAll);
	DDX_Control(pDX, IDC_BUTTON_SEARCH_RESULT, m_btnResultSearch);
	DDX_Control(pDX, IDC_BUTTON_SEARCH_FIRST, m_btnFirstSearch);
	DDX_Control(pDX, IDC_LIST_RESULT, m_lstCtrlResult);
	DDX_Control(pDX, IDC_PROGRESS_SEARCH, m_ctlProSearch);
	DDX_Text(pDX, IDC_EDIT_ADDRESS, m_strAddress);
	DDV_MaxChars(pDX, m_strAddress, 8);
	DDX_Text(pDX, IDC_EDIT_MODIFY_VALUE, m_strModify);
	DDV_MaxChars(pDX, m_strModify, SEARCH_STRING_MAX_LENGTH / 2 - 1);
	DDX_Text(pDX, IDC_EDIT_SEARCH_MAX_VALUE, m_strSearchMax);
	DDX_Text(pDX, IDC_EDIT_SEARCH_MIN_VALUE, m_strSearchMin);
	DDV_MaxChars(pDX, m_strSearchMin, SEARCH_STRING_MAX_LENGTH / 2 - 1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CModifyMemoryDlg, CDialog)
	//{{AFX_MSG_MAP(CModifyMemoryDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_SEARCH_FIRST, OnButtonSearchFirst)
	ON_BN_CLICKED(IDC_BUTTON_SEARCH_RESULT, OnButtonSearchResult)
	ON_BN_CLICKED(IDC_BUTTON_SELECT_ALL, OnButtonSelectAll)
	ON_BN_CLICKED(IDC_BUTTON_CANCEL_SELECT, OnButtonCancelSelect)
	ON_BN_CLICKED(IDC_BUTTON_MODIFY_NUMBER, OnButtonModifyNumber)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON_REFRESH, OnButtonRefresh)
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_RESELECT, OnButtonReselect)
	ON_BN_CLICKED(IDC_BUTTON_EXPORT_SELECT, OnButtonExportSelect)
	ON_BN_CLICKED(IDC_BUTTON_INPORT_FILE, OnButtonInportFile)
	ON_CBN_SELCHANGE(IDC_COMBO_SEARCH_MODE, OnSelchangeComboSearchMode)
	ON_CBN_SELCHANGE(IDC_COMBO_SEARCH_TYPE, OnSelchangeComboSearchType)
	ON_MESSAGE(WM_FIND_MEMORY, FindMemroyFunc)
	ON_MESSAGE(WM_FIND_PROGRESS, SearchProcessFunc)
	ON_MESSAGE(WM_SEARCH_FINISH, SearchFinishFunc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CModifyMemoryDlg message handlers

BOOL CModifyMemoryDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	Init();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CModifyMemoryDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CModifyMemoryDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CModifyMemoryDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CModifyMemoryDlg::OnClose() 
{
	if (NULL != m_pThreadSeq)
	{
		delete [] m_pThreadSeq;
		m_pThreadSeq = NULL;
	}

	if (NULL != m_hProcess)
	{
		CloseHandle(m_hProcess);
		m_hProcess = NULL;
	}

	if (NULL != m_pSearchMinBuf)
	{
		delete [] m_pSearchMinBuf;
		m_pSearchMinBuf = NULL;
	}

	if (NULL != m_pSearchMaxBuf)
	{
		delete [] m_pSearchMaxBuf;
		m_pSearchMaxBuf = NULL;
	}

	for (int i = 0; i < m_aryResult.GetSize(); i++)
	{
		delete (SEARCH_RESULT *)m_aryResult.GetAt(i);
	}
	m_aryResult.RemoveAll();
	
	CDialog::OnClose();
}

void CModifyMemoryDlg::OnButtonSearchFirst() 
{
	CString strBtnTxt;
	m_btnFirstSearch.GetWindowText(strBtnTxt);
	if (0 == strBtnTxt.CompareNoCase("ֹͣ"))
	{
		m_bRunSearch = FALSE;
		return ;
	}

	UpdateData(TRUE);

	if (FALSE == CanFirstSearch() || FALSE == OpenThread())
	{
		return ;
	}

	m_dwReadCount = 0;
	m_ctlProSearch.SetRange(0, PROCESS_SIZE);
	m_ctlProSearch.SetPos(0);

	m_btnFirstSearch.SetWindowText("ֹͣ");
	m_btnCancelSelect.EnableWindow(FALSE);
	m_btnModifyNumber.EnableWindow(FALSE);
	m_btnSelectAll.EnableWindow(FALSE);
	m_btnResultSearch.EnableWindow(FALSE);
	m_btnRefresh.EnableWindow(FALSE);
	m_btnAdd.EnableWindow(FALSE);
	m_btnReSelectProcess.EnableWindow(FALSE);
	m_btnExportSelect.EnableWindow(FALSE);
	m_btnInportFile.EnableWindow(FALSE);
	GetDlgItem(IDC_COMBO_SEARCH_TYPE)->EnableWindow(FALSE);
	GetDlgItem(IDC_COMBO_SEARCH_MODE)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_SEARCH_MIN_VALUE)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_SEARCH_MAX_VALUE)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_UNICODE)->EnableWindow(FALSE);

	m_lstCtrlResult.DeleteAllItems();
	for (int i = m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1; i >= 2 ; i--)
	{
		m_lstCtrlResult.DeleteColumn(i);
	}

	for (i = 0; i < m_aryResult.GetSize(); i++)
	{
		delete (SEARCH_RESULT *)m_aryResult.GetAt(i);
	}
	m_aryResult.RemoveAll();

	m_nThreadActivateCount	= 0;
	m_bRunSearch			= TRUE;
	for (i = 0; i < THREAD_NUM; i++)
	{
		m_pThreadSeq[i] = i;
		CreateThread(NULL, 0, SearchMemory, &m_pThreadSeq[i], 0, NULL);
		m_nThreadActivateCount++;
	}
}

void CModifyMemoryDlg::OnButtonSearchResult() 
{
	UpdateData(TRUE);

	if (FALSE == CanResultSearch() ||
		(NULL == m_hProcess && FALSE == OpenThread()))
	{
		return ;
	}

	CString strTmp;
	strTmp.Format("%dֵ", 
		m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1);
	m_lstCtrlResult.InsertColumn(m_lstCtrlResult.GetHeaderCtrl()->GetItemCount(), 
		strTmp, LVCFMT_LEFT, 80);

	int nSearchTypeSel = m_comboxSearchType.GetCurSel();
	int nSearchModeSel = m_comboxSearchMode.GetCurSel();
	
	ENUM_SEARCH_TYPE enumSearchType = searchType[nSearchTypeSel].enumType;
	ENUM_SEARCH_MODE enumSearchMode = searchMode[nSearchModeSel].enumMode;

	if (ENUM_SEARCH_STRING == enumSearchType)
	{
		if (ENUM_SEARCH_EQU == enumSearchMode)
		{
			// UNICODEַĵ
			if (FALSE == m_btnUnicode.GetCheck())
			{
				BYTE pBuf[SEARCH_STRING_MAX_LENGTH];
				for (int i = m_lstCtrlResult.GetItemCount() - 1; i >= 0; i--)
				{
					if (FALSE == ReadProcessMemory(m_hProcess, 
						(LPCVOID)((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress, 
						pBuf, m_nSearchSize, NULL))
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
			 			m_lstCtrlResult.DeleteItem(i);
						continue ;
					}
					if (0 == memcmp(m_pSearchMinBuf, pBuf, m_nSearchSize - 1))
					{
						pBuf[m_nSearchSize-1] = 0;
						strTmp.Format("%s", pBuf);
				 		m_lstCtrlResult.SetItemText(i, 
		 					m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
			 			m_lstCtrlResult.SetItemText(i, 1, strTmp);

						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
			 			m_lstCtrlResult.DeleteItem(i);
					}
				}
			}
			else
			{
				BYTE pBuf[SEARCH_STRING_MAX_LENGTH];
				for (int i = m_lstCtrlResult.GetItemCount() - 1; i >= 0; i--)
				{
					if (FALSE == ReadProcessMemory(m_hProcess, 
						(LPCVOID)((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress, 
						pBuf, m_nSearchSize, NULL))
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
						continue ;
					}
					if (0 == memcmp(m_pSearchMinBuf, pBuf, m_nSearchSize - 2))
					{
						pBuf[m_nSearchSize-1] = 0;
						pBuf[m_nSearchSize-2] = 0;
						strTmp = (LPWSTR)pBuf;
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);

						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
			}
		}
		else if (ENUM_SEARCH_CHANGE == enumSearchMode)
		{
			// UNICODEַı仯
			if (FALSE == m_btnUnicode.GetCheck())
			{
				BYTE pBuf[SEARCH_STRING_MAX_LENGTH];
				for (int i = m_lstCtrlResult.GetItemCount() - 1; i >= 0; i--)
				{
					m_nSearchSize = ((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize;
					if (FALSE == ReadProcessMemory(m_hProcess, 
						(LPCVOID)((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress, 
						pBuf, m_nSearchSize, NULL))
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
						continue ;
					}
					if (0 != memcmp(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue, 
						pBuf, m_nSearchSize - 1))
					{
						pBuf[m_nSearchSize-1] = 0;
						strTmp.Format("%s", pBuf);
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
			}
			else
			{
				BYTE pBuf[SEARCH_STRING_MAX_LENGTH];
				for (int i = m_lstCtrlResult.GetItemCount() - 1; i >= 0; i--)
				{
					m_nSearchSize = ((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize;
					if (FALSE == ReadProcessMemory(m_hProcess, 
						(LPCVOID)((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress, 
						pBuf, m_nSearchSize, NULL))
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
						continue ;
					}
					if (0 != memcmp(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue, 
						pBuf, m_nSearchSize - 2))
					{
						pBuf[m_nSearchSize-1] = 0;
						pBuf[m_nSearchSize-2] = 0;
						strTmp = (LPWSTR)pBuf;
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
			}
		}
	}
	else		// ֵ
	{
		if (ENUM_SEARCH_EQU == enumSearchMode)
		{
			BYTE pBuf[SEARCH_STRING_MAX_LENGTH];
			for (int i = m_lstCtrlResult.GetItemCount() - 1; i >= 0; i--)
			{
				if (FALSE == ReadProcessMemory(m_hProcess, 
					(LPCVOID)((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress, 
					pBuf, m_nSearchSize, NULL))
				{
					delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
					m_aryResult.RemoveAt(i);
					m_lstCtrlResult.DeleteItem(i);
					continue ;
				}

				if (0 == memcmp(m_pSearchMinBuf, pBuf, m_nSearchSize))
				{
					if (ENUM_SEARCH_CHAR == enumSearchType)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(char*)pBuf);
					}
					if (ENUM_SEARCH_2CHARS == enumSearchType)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(short*)pBuf);
					}
					if (ENUM_SEARCH_4CHARS == enumSearchType)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(int*)pBuf);
					}
					if (ENUM_SEARCH_8CHARS == enumSearchType)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(__int64*)pBuf);
					}
					if (ENUM_SEARCH_FLOAT == enumSearchType)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(float*)pBuf);
					}
					if (ENUM_SEARCH_DOUBLE == enumSearchType)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(double*)pBuf);
					}

					m_lstCtrlResult.SetItemText(i, 
						m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
					m_lstCtrlResult.SetItemText(i, 1, strTmp);

					((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
					memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
						pBuf, m_nSearchSize);
				}
				else
				{
					delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
					m_aryResult.RemoveAt(i);
					m_lstCtrlResult.DeleteItem(i);
				}
			}
		}
		else if (ENUM_SEARCH_GREATER == enumSearchMode)
		{
			BYTE pBuf[SEARCH_STRING_MAX_LENGTH];
			for (int i = m_lstCtrlResult.GetItemCount() - 1; i >= 0; i--)
			{
				if (FALSE == ReadProcessMemory(m_hProcess, 
					(LPCVOID)((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress, 
					pBuf, m_nSearchSize, NULL))
				{
					delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
					m_aryResult.RemoveAt(i);
					m_lstCtrlResult.DeleteItem(i);
					continue ;
				}
				
				if (ENUM_SEARCH_CHAR == enumSearchType)
				{
					if (*(char*)m_pSearchMinBuf < *(char*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(char*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_2CHARS == enumSearchType)
				{
					if (*(short*)m_pSearchMinBuf < *(short*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(short*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_4CHARS == enumSearchType)
				{
					if (*(int*)m_pSearchMinBuf < *(int*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(int*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_8CHARS == enumSearchType)
				{
					if (*(__int64*)m_pSearchMinBuf < *(__int64*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(__int64*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_FLOAT == enumSearchType)
				{
					if (*(float*)m_pSearchMinBuf < *(float*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(float*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_DOUBLE == enumSearchType)
				{
					if (*(double*)m_pSearchMinBuf < *(double*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(double*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
			}
		}
		else if (ENUM_SEARCH_SMALLER == enumSearchMode)
		{
			BYTE pBuf[SEARCH_STRING_MAX_LENGTH];
			for (int i = m_lstCtrlResult.GetItemCount() - 1; i >= 0; i--)
			{
				if (FALSE == ReadProcessMemory(m_hProcess, 
					(LPCVOID)((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress, 
					pBuf, m_nSearchSize, NULL))
				{
					delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
					m_aryResult.RemoveAt(i);
					m_lstCtrlResult.DeleteItem(i);
					continue ;
				}
				
				if (ENUM_SEARCH_CHAR == enumSearchType)
				{
					if (*(char*)m_pSearchMinBuf > *(char*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(char*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_2CHARS == enumSearchType)
				{
					if (*(short*)m_pSearchMinBuf > *(short*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(short*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_4CHARS == enumSearchType)
				{
					if (*(int*)m_pSearchMinBuf > *(int*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(int*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_8CHARS == enumSearchType)
				{
					if (*(__int64*)m_pSearchMinBuf > *(__int64*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(__int64*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_FLOAT == enumSearchType)
				{
					if (*(float*)m_pSearchMinBuf > *(float*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(float*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_DOUBLE == enumSearchType)
				{
					if (*(double*)m_pSearchMinBuf > *(double*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(double*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
			}
		}
		else if (ENUM_SEARCH_RANGE == enumSearchMode)
		{
			BYTE pBuf[SEARCH_STRING_MAX_LENGTH];
			for (int i = m_lstCtrlResult.GetItemCount() - 1; i >= 0; i--)
			{
				if (FALSE == ReadProcessMemory(m_hProcess, 
					(LPCVOID)((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress, 
					pBuf, m_nSearchSize, NULL))
				{
					delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
					m_aryResult.RemoveAt(i);
					m_lstCtrlResult.DeleteItem(i);
					continue ;
				}
				
				if (ENUM_SEARCH_CHAR == enumSearchType)
				{
					if (*(char*)m_pSearchMinBuf < *(char*)pBuf
						&& *(char*)m_pSearchMaxBuf > *(char*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(char*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_2CHARS == enumSearchType)
				{
					if (*(short*)m_pSearchMinBuf < *(short*)pBuf
						&& *(short*)m_pSearchMaxBuf > *(short*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(short*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_4CHARS == enumSearchType)
				{
					if (*(int*)m_pSearchMinBuf < *(int*)pBuf
						&& *(int*)m_pSearchMaxBuf > *(int*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(int*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_8CHARS == enumSearchType)
				{
					if (*(__int64*)m_pSearchMinBuf < *(__int64*)pBuf
						&& *(__int64*)m_pSearchMaxBuf > *(__int64*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(__int64*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_FLOAT == enumSearchType)
				{
					if (*(float*)m_pSearchMinBuf < *(float*)pBuf
						&& *(float*)m_pSearchMaxBuf > *(float*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(float*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_DOUBLE == enumSearchType)
				{
					if (*(double*)m_pSearchMinBuf < *(double*)pBuf
						&& *(double*)m_pSearchMaxBuf > *(double*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(double*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
			}
		}
		else if (ENUM_SEARCH_INCREASE == enumSearchMode)
		{
			BYTE pBuf[SEARCH_STRING_MAX_LENGTH];
			for (int i = m_lstCtrlResult.GetItemCount() - 1; i >= 0; i--)
			{
				if (FALSE == ReadProcessMemory(m_hProcess, 
					(LPCVOID)((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress, 
					pBuf, m_nSearchSize, NULL))
				{
					delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
					m_aryResult.RemoveAt(i);
					m_lstCtrlResult.DeleteItem(i);
					continue ;
				}
				
				if (ENUM_SEARCH_CHAR == enumSearchType)
				{
					if (*(char*)((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue < *(char*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(char*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_2CHARS == enumSearchType)
				{
					if (*(short*)((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue < *(short*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(short*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_4CHARS == enumSearchType)
				{
					if (*(int*)((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue < *(int*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(int*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_8CHARS == enumSearchType)
				{
					if (*(__int64*)((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue < *(__int64*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(__int64*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_FLOAT == enumSearchType)
				{
					if (*(float*)((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue < *(float*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(float*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_DOUBLE == enumSearchType)
				{
					if (*(double*)((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue < *(double*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(double*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
			}
		}
		else if (ENUM_SEARCH_DECREASE == enumSearchMode)
		{
			BYTE pBuf[SEARCH_STRING_MAX_LENGTH];
			for (int i = m_lstCtrlResult.GetItemCount() - 1; i >= 0; i--)
			{
				if (FALSE == ReadProcessMemory(m_hProcess, 
					(LPCVOID)((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress, 
					pBuf, m_nSearchSize, NULL))
				{
					delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
					m_aryResult.RemoveAt(i);
					m_lstCtrlResult.DeleteItem(i);
					continue ;
				}
				
				if (ENUM_SEARCH_CHAR == enumSearchType)
				{
					if (*(char*)((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue > *(char*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(char*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_2CHARS == enumSearchType)
				{
					if (*(short*)((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue > *(short*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(short*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_4CHARS == enumSearchType)
				{
					if (*(int*)((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue > *(int*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(int*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_8CHARS == enumSearchType)
				{
					if (*(__int64*)((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue > *(__int64*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(__int64*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_FLOAT == enumSearchType)
				{
					if (*(float*)((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue > *(float*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(float*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
				else if (ENUM_SEARCH_DOUBLE == enumSearchType)
				{
					if (*(double*)((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue > *(double*)pBuf)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(double*)pBuf);
						
						m_lstCtrlResult.SetItemText(i, 
							m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
						m_lstCtrlResult.SetItemText(i, 1, strTmp);
						
						((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
						memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
							pBuf, m_nSearchSize);
					}
					else
					{
						delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
						m_aryResult.RemoveAt(i);
						m_lstCtrlResult.DeleteItem(i);
					}
				}
			}
		}
		else if (ENUM_SEARCH_CHANGE == enumSearchMode)
		{
			BYTE pBuf[SEARCH_STRING_MAX_LENGTH];
			for (int i = m_lstCtrlResult.GetItemCount() - 1; i >= 0; i--)
			{
				if (FALSE == ReadProcessMemory(m_hProcess, 
					(LPCVOID)((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress, 
					pBuf, m_nSearchSize, NULL))
				{
					delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
					m_aryResult.RemoveAt(i);
					m_lstCtrlResult.DeleteItem(i);
					continue ;
				}
				
				if (0 != memcmp(m_pSearchMinBuf, pBuf, m_nSearchSize))
				{
					if (ENUM_SEARCH_CHAR == enumSearchType)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(char*)pBuf);
					}
					if (ENUM_SEARCH_2CHARS == enumSearchType)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(short*)pBuf);
					}
					if (ENUM_SEARCH_4CHARS == enumSearchType)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(int*)pBuf);
					}
					if (ENUM_SEARCH_8CHARS == enumSearchType)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(__int64*)pBuf);
					}
					if (ENUM_SEARCH_FLOAT == enumSearchType)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(float*)pBuf);
					}
					if (ENUM_SEARCH_DOUBLE == enumSearchType)
					{
						strTmp.Format(searchType[nSearchTypeSel].pFormat, *(double*)pBuf);
					}
					
					m_lstCtrlResult.SetItemText(i, 
						m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1, strTmp);
					m_lstCtrlResult.SetItemText(i, 1, strTmp);
					
					((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
					memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
						pBuf, m_nSearchSize);
				}
				else
				{
					delete (SEARCH_RESULT*)m_aryResult.GetAt(i);
					m_aryResult.RemoveAt(i);
					m_lstCtrlResult.DeleteItem(i);
				}
			}
		}
	}

	if (0 == m_lstCtrlResult.GetItemCount())
	{
		m_btnCancelSelect.EnableWindow(FALSE);
		m_btnModifyNumber.EnableWindow(FALSE);
		m_btnSelectAll.EnableWindow(FALSE);
		m_btnResultSearch.EnableWindow(FALSE);
		m_btnRefresh.EnableWindow(FALSE);
		m_btnExportSelect.EnableWindow(FALSE);
	}

	strTmp.Format(" (%d)", m_aryResult.GetSize());
	SetWindowText(m_strTitle + strTmp);
}

void CModifyMemoryDlg::OnButtonSelectAll() 
{
	for (int i = 0; i < m_lstCtrlResult.GetItemCount(); i++)
	{
		m_lstCtrlResult.SetCheck(i, TRUE);
	}
}

void CModifyMemoryDlg::OnButtonCancelSelect() 
{
	for (int i = 0; i < m_lstCtrlResult.GetItemCount(); i++)
	{
		m_lstCtrlResult.SetCheck(i, FALSE);
	}
}

void CModifyMemoryDlg::OnButtonModifyNumber() 
{
	if (NULL == m_hProcess && FALSE == OpenThread())
	{
		return ;
	}

	int nCheckCount = 0;
	for (int i = 0; i < m_lstCtrlResult.GetItemCount(); i++)
	{
		if( FALSE != m_lstCtrlResult.GetCheck(i))
		{
			nCheckCount++;
		}
	}
	if (0 == nCheckCount)
	{
		AfxMessageBox("ûѡҪ޸ĵڴַ!");
		return ;
	}

	if (IDCANCEL == AfxMessageBox("Ƿ޸ѡڴֵַ", MB_OKCANCEL))
	{
		return ;
	}

	UpdateData(TRUE);

	int nSearchTypeSel = m_comboxSearchType.GetCurSel();
	
	ENUM_SEARCH_TYPE enumSearchType = searchType[nSearchTypeSel].enumType;

	// ı
	if (ENUM_SEARCH_STRING != enumSearchType)
	{
		m_nSearchSize = searchType[nSearchTypeSel].nSize;
		
		if (m_nSearchSize > m_nMinBufSize)
		{
			delete [] m_pSearchMinBuf;
			m_nMinBufSize = m_nSearchSize;
			m_pSearchMinBuf = new BYTE[m_nMinBufSize];
		}
		sscanf(m_strModify, searchType[nSearchTypeSel].pFormat, m_pSearchMinBuf);
	}
	else
	{
		// ıUNICODE
		if (FALSE != m_btnUnicode.GetCheck())
		{
			USES_CONVERSION ;   
			LPWSTR lpwSearchString = A2W(m_strModify);
			m_nSearchSize = (lstrlenW(lpwSearchString) + 1) * 2;
			
			if (m_nSearchSize > m_nMinBufSize)
			{
				delete [] m_pSearchMinBuf;
				m_nMinBufSize = m_nSearchSize;
				m_pSearchMinBuf = new BYTE[m_nMinBufSize];
			}
			
			memcpy(m_pSearchMinBuf, lpwSearchString, m_nMinBufSize);
		}
		else
		{
			m_nSearchSize = m_strModify.GetLength() + 1;
			if (m_nSearchSize > m_nMinBufSize)
			{
				delete [] m_pSearchMinBuf;
				m_nMinBufSize = m_nSearchSize;
				m_pSearchMinBuf = new BYTE[m_nMinBufSize];
			}
			sscanf(m_strModify, searchType[nSearchTypeSel].pFormat, m_pSearchMinBuf);
		}
	}
	
	MEMORY_BASIC_INFORMATION mbi;
	DWORD dwOldProtect;
	for (i = 0; i < m_lstCtrlResult.GetItemCount(); i++)
	{
		if( FALSE != m_lstCtrlResult.GetCheck(i))
		{
			if (sizeof(mbi) != VirtualQueryEx(m_hProcess, 
				(LPCVOID)((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress, &mbi, sizeof(mbi)))
			{
				CString strPrompt;
				strPrompt.Format("ѯ0x%xҳϢʧ", 
					(LPCVOID)((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress);
				AfxMessageBox(strPrompt);
				continue ;
			}

			if (FALSE == VirtualProtectEx(m_hProcess, mbi.BaseAddress, mbi.RegionSize,
				PAGE_EXECUTE_READWRITE, &dwOldProtect))
			{
				CString strPrompt;
				strPrompt.Format("0x%xҳʧ", 
					(LPCVOID)((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress);
				AfxMessageBox(strPrompt);
				continue ;
			}

			CString strPrompt;
			BOOL bRet = FALSE;

			// ޸UNICODEַ
			if (ENUM_SEARCH_STRING == enumSearchType)
			{
				if (FALSE != m_btnUnicode.GetCheck())
				{
					bRet = WriteProcessMemory(m_hProcess, 
						(LPVOID)((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress, 
						m_pSearchMinBuf, m_nSearchSize - 2, NULL);
				}
				else
				{
					bRet = WriteProcessMemory(m_hProcess, 
						(LPVOID)((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress, 
						m_pSearchMinBuf, m_nSearchSize - 1, NULL);
				}
			}
			else
			{
				bRet = WriteProcessMemory(m_hProcess, 
					(LPVOID)((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress, 
					m_pSearchMinBuf, m_nSearchSize, NULL);
			}
			
			if (FALSE == bRet)
			{
				strPrompt.Format("޸0x%xֵʧ", 
					(LPCVOID)((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress);
				AfxMessageBox(strPrompt);
			}
			else
			{
				if (ENUM_SEARCH_CHAR == enumSearchType)
				{
					strPrompt.Format(searchType[nSearchTypeSel].pFormat, *(char*)m_pSearchMinBuf);
				}
				if (ENUM_SEARCH_2CHARS == enumSearchType)
				{
					strPrompt.Format(searchType[nSearchTypeSel].pFormat, *(short*)m_pSearchMinBuf);
				}
				if (ENUM_SEARCH_4CHARS == enumSearchType)
				{
					strPrompt.Format(searchType[nSearchTypeSel].pFormat, *(int*)m_pSearchMinBuf);
				}
				if (ENUM_SEARCH_8CHARS == enumSearchType)
				{
					strPrompt.Format(searchType[nSearchTypeSel].pFormat, *(__int64*)m_pSearchMinBuf);
				}
				if (ENUM_SEARCH_FLOAT == enumSearchType)
				{
					strPrompt.Format(searchType[nSearchTypeSel].pFormat, *(float*)m_pSearchMinBuf);
				}
				if (ENUM_SEARCH_DOUBLE == enumSearchType)
				{
					strPrompt.Format(searchType[nSearchTypeSel].pFormat, *(double*)m_pSearchMinBuf);
				}
				if (ENUM_SEARCH_STRING == enumSearchType)
				{
					if (FALSE == m_btnUnicode.GetCheck())
					{
						m_pSearchMinBuf[m_nSearchSize-1] = 0;
						strPrompt.Format("%s", m_pSearchMinBuf);
					}
					else
					{
						m_pSearchMinBuf[m_nSearchSize-1] = 0;
						m_pSearchMinBuf[m_nSearchSize-2] = 0;
						strPrompt = (LPWSTR)m_pSearchMinBuf;
					}
				}
				m_lstCtrlResult.SetItemText(i, 1, strPrompt);
			}
			if (FALSE == VirtualProtectEx(m_hProcess, mbi.BaseAddress, mbi.RegionSize,
				dwOldProtect, &dwOldProtect))
			{
				CString strPrompt;
				strPrompt.Format("ָ0x%xҳʧ", 
					(LPCVOID)((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress);
				AfxMessageBox(strPrompt);
			}
			
		}
	}
}

void CModifyMemoryDlg::Init()
{
	m_dwProcessID			= 0;
	m_dwMinAddress			= 0;
	m_dwMaxAddress			= 0;
	m_hProcess				= NULL;
	m_dwReadCount			= 0;
	m_pThreadSeq			= NULL;
	m_nThreadActivateCount	= 0;
	m_bRunSearch			= FALSE;
	m_pThreadSeq			= new int[THREAD_NUM];

	for (int i = 0; i < sizeof(searchType)/sizeof(searchType[0]); i++)
	{
		m_comboxSearchType.InsertString(i, searchType[i].pTitle);
	}
	m_comboxSearchType.SetCurSel(2);
	m_btnUnicode.ShowWindow(FALSE);
	m_nMinBufSize    = searchType[m_comboxSearchType.GetCurSel()].nSize;
	m_pSearchMinBuf  = new BYTE[m_nMinBufSize];
	m_nSearchSize    = m_nMinBufSize;
	m_nMaxBufSize	 = m_nMinBufSize;
	m_pSearchMaxBuf  = new BYTE[m_nMaxBufSize];

	for (i = 0; i < sizeof(searchMode)/sizeof(searchMode[0]); i++ )
	{
		m_comboxSearchMode.InsertString(i, searchMode[i].pTitle);
	}
	m_comboxSearchMode.SetCurSel(0);
	i = m_comboxSearchMode.GetCurSel();

	GetDlgItem(IDC_STATIC_VALUE)->ShowWindow(i <= 3);
	GetDlgItem(IDC_EDIT_SEARCH_MIN_VALUE)->ShowWindow(i <= 3);
	GetDlgItem(IDC_STATIC_TO)->ShowWindow(i == 3);
	GetDlgItem(IDC_EDIT_SEARCH_MAX_VALUE)->ShowWindow(i == 3);

	SYSTEM_INFO sysInfo;
	GetSystemInfo(&sysInfo);
	m_dwMinAddress = (DWORD)sysInfo.lpMinimumApplicationAddress;
	m_dwMaxAddress = (DWORD)sysInfo.lpMaximumApplicationAddress;

	m_lstCtrlResult.SetExtendedStyle(LVS_EX_CHECKBOXES | LVS_EX_FULLROWSELECT);
	m_lstCtrlResult.InsertColumn(0, "ַ", LVCFMT_LEFT, 100);
	m_lstCtrlResult.InsertColumn(1, "ǰֵ", LVCFMT_LEFT, 80);

	m_btnCancelSelect.EnableWindow(FALSE);
	m_btnModifyNumber.EnableWindow(FALSE);
	m_btnSelectAll.EnableWindow(FALSE);
	m_btnResultSearch.EnableWindow(FALSE);
	m_btnRefresh.EnableWindow(FALSE);
	m_btnExportSelect.EnableWindow(FALSE);

	UpdateData(FALSE);

	HANDLE			 hToken;
	TOKEN_PRIVILEGES tp;
	LUID			 luid;
	
	OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES, &hToken);
	
	LookupPrivilegeValue(NULL, SE_DEBUG_NAME, &luid);
 
	tp.PrivilegeCount = 1;
	tp.Privileges[0].Luid = luid;
	tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
	
	AdjustTokenPrivileges(hToken, FALSE, &tp, sizeof(tp), NULL, NULL);
	CloseHandle(hToken);
}

LRESULT CModifyMemoryDlg::FindMemroyFunc(WPARAM wParam, LPARAM lParam)
{
	int i = 0;
	DWORD dwAddress = (DWORD)wParam;
	CString strTmp;
	
	for (i = 0; i < m_aryResult.GetSize(); i++)
	{
		if (dwAddress < ((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress)
		{
			break;
		}
		else if (dwAddress == ((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress)
		{
			return 0;
		}
	}
	strTmp.Format("0x%08x", dwAddress);
	m_lstCtrlResult.InsertItem(i, strTmp);

	SEARCH_RESULT *pSearchResult = new SEARCH_RESULT();
	pSearchResult->dwAddress = dwAddress;
	pSearchResult->nValueSize = m_nSearchSize;
	memcpy(pSearchResult->pValue, m_pSearchMinBuf, m_nSearchSize);
	m_aryResult.InsertAt(i, pSearchResult);

	if (2 == m_lstCtrlResult.GetHeaderCtrl()->GetItemCount())
	{
		strTmp.Format("%dֵ", 
			m_lstCtrlResult.GetHeaderCtrl()->GetItemCount() - 1);
		m_lstCtrlResult.InsertColumn(2, strTmp, LVCFMT_LEFT, 80);
	}

	int nSearchTypeSel = m_comboxSearchType.GetCurSel();
	int nSearchModeSel = m_comboxSearchMode.GetCurSel();
	
	ENUM_SEARCH_TYPE enumSearchType = searchType[nSearchTypeSel].enumType;
	ENUM_SEARCH_MODE enumSearchMode = searchMode[nSearchModeSel].enumMode;

	if (ENUM_SEARCH_EQU == enumSearchMode)
	{
		if (ENUM_SEARCH_CHAR == enumSearchType)
		{
			strTmp.Format(searchType[nSearchTypeSel].pFormat, *(char*)m_pSearchMinBuf);
		}
		if (ENUM_SEARCH_2CHARS == enumSearchType)
		{
			strTmp.Format(searchType[nSearchTypeSel].pFormat, *(short*)m_pSearchMinBuf);
		}
		if (ENUM_SEARCH_4CHARS == enumSearchType)
		{
			strTmp.Format(searchType[nSearchTypeSel].pFormat, *(int*)m_pSearchMinBuf);
		}
		if (ENUM_SEARCH_8CHARS == enumSearchType)
		{
			strTmp.Format(searchType[nSearchTypeSel].pFormat, *(__int64*)m_pSearchMinBuf);
		}
		if (ENUM_SEARCH_FLOAT == enumSearchType)
		{
			strTmp.Format(searchType[nSearchTypeSel].pFormat, *(float*)m_pSearchMinBuf);
		}
		if (ENUM_SEARCH_DOUBLE == enumSearchType)
		{
			strTmp.Format(searchType[nSearchTypeSel].pFormat, *(double*)m_pSearchMinBuf);
		}
		if (ENUM_SEARCH_STRING == enumSearchType)
		{
			if (FALSE == m_btnUnicode.GetCheck())
			{
				m_pSearchMinBuf[m_nSearchSize-1] = 0;
				strTmp.Format("%s", m_pSearchMinBuf);
			}
			else
			{
				m_pSearchMinBuf[m_nSearchSize-1] = 0;
				m_pSearchMinBuf[m_nSearchSize-2] = 0;
				strTmp = (LPWSTR)m_pSearchMinBuf;
			}
		}

		m_lstCtrlResult.SetItemText(i, 1, strTmp);
		m_lstCtrlResult.SetItemText(i, 2, strTmp);
	}
	else if (ENUM_SEARCH_GREATER == enumSearchMode
			 || ENUM_SEARCH_SMALLER == enumSearchMode
			 || ENUM_SEARCH_RANGE == enumSearchMode
			 || ENUM_SEARCH_INCREASE == enumSearchMode
			 || ENUM_SEARCH_DECREASE == enumSearchMode
			 || ENUM_SEARCH_CHANGE == enumSearchMode)
	{
		if (ENUM_SEARCH_CHAR == enumSearchType)
		{
			strTmp.Format(searchType[nSearchTypeSel].pFormat, (char)lParam);
		}
		else if (ENUM_SEARCH_2CHARS == enumSearchType)
		{
			strTmp.Format(searchType[nSearchTypeSel].pFormat, (short)lParam);
		}
		else if (ENUM_SEARCH_4CHARS == enumSearchType)
		{
			strTmp.Format(searchType[nSearchTypeSel].pFormat, (int)lParam);
		}
		else if (ENUM_SEARCH_8CHARS == enumSearchType)
		{
			strTmp.Format(searchType[nSearchTypeSel].pFormat, *(__int64*)lParam);
		}
		else if (ENUM_SEARCH_FLOAT == enumSearchType)
		{
			strTmp.Format(searchType[nSearchTypeSel].pFormat, (float)lParam);
		}
		else if (ENUM_SEARCH_DOUBLE == enumSearchType)
		{
			strTmp.Format(searchType[nSearchTypeSel].pFormat, *(double*)lParam);
		}

		m_lstCtrlResult.SetItemText(i, 1, strTmp);
		m_lstCtrlResult.SetItemText(i, 2, strTmp);
	}
	
	strTmp.Format(" (%d)", m_aryResult.GetSize());
	SetWindowText(m_strTitle + strTmp);

	return 0;
}

LRESULT CModifyMemoryDlg::SearchProcessFunc(WPARAM wParam, LPARAM lParam)
{
	DWORD dwReadCount = (DWORD)wParam;
	m_dwReadCount += dwReadCount;
	int nProgress = ((DWORD64)m_dwReadCount) * PROCESS_SIZE / (m_dwMaxAddress - m_dwMinAddress);
	m_ctlProSearch.SetPos(nProgress);
	return 0;
}

LRESULT CModifyMemoryDlg::SearchFinishFunc(WPARAM wParam, LPARAM lParam)
{
	m_nThreadActivateCount--;
	if (0 == m_nThreadActivateCount)
	{
		m_btnFirstSearch.SetWindowText("һ");
		if (0 != m_aryResult.GetSize())
		{
			m_btnCancelSelect.EnableWindow(TRUE);
			m_btnModifyNumber.EnableWindow(TRUE);
			m_btnSelectAll.EnableWindow(TRUE);
			m_btnResultSearch.EnableWindow(TRUE);
			m_btnRefresh.EnableWindow(TRUE);
			m_btnExportSelect.EnableWindow(TRUE);
		}
		m_btnAdd.EnableWindow(TRUE);
		m_btnReSelectProcess.EnableWindow(TRUE);
		m_btnInportFile.EnableWindow(TRUE);
		GetDlgItem(IDC_COMBO_SEARCH_TYPE)->EnableWindow(TRUE);
		GetDlgItem(IDC_COMBO_SEARCH_MODE)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_SEARCH_MIN_VALUE)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_SEARCH_MAX_VALUE)->EnableWindow(TRUE);
		GetDlgItem(IDC_CHECK_UNICODE)->EnableWindow(TRUE);
	}
	return 0;
}

void CModifyMemoryDlg::OnButtonRefresh() 
{
	UpdateData(TRUE);
	
	if (NULL == m_hProcess && FALSE == OpenThread())
	{
		return ;
	}

	int nSearchTypeSel = m_comboxSearchType.GetCurSel();
	
	ENUM_SEARCH_TYPE enumSearchType = searchType[nSearchTypeSel].enumType;

	m_nSearchSize = searchType[nSearchTypeSel].nSize;
	
	if (m_nSearchSize > m_nMinBufSize)
	{
		delete [] m_pSearchMinBuf;
		m_nMinBufSize = m_nSearchSize;
		m_pSearchMinBuf = new BYTE[m_nMinBufSize];
	}
	
	CString strTmp;
	DWORD64 dw64Read = 0;
	for (int i = m_lstCtrlResult.GetItemCount() - 1; i >= 0; i--)
	{
		if (FALSE == ReadProcessMemory(m_hProcess, 
			(LPCVOID)((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress, 
			m_pSearchMinBuf, m_nSearchSize, NULL))
		{
			strTmp = "ʧ";
		}
		else
		{
			if (ENUM_SEARCH_CHAR == enumSearchType)
			{
				strTmp.Format(searchType[nSearchTypeSel].pFormat, *(char*)m_pSearchMinBuf);
			}
			if (ENUM_SEARCH_2CHARS == enumSearchType)
			{
				strTmp.Format(searchType[nSearchTypeSel].pFormat, *(short*)m_pSearchMinBuf);
			}
			if (ENUM_SEARCH_4CHARS == enumSearchType)
			{
				strTmp.Format(searchType[nSearchTypeSel].pFormat, *(int*)m_pSearchMinBuf);
			}
			if (ENUM_SEARCH_8CHARS == enumSearchType)
			{
				strTmp.Format(searchType[nSearchTypeSel].pFormat, *(__int64*)m_pSearchMinBuf);
			}
			if (ENUM_SEARCH_FLOAT == enumSearchType)
			{
				strTmp.Format(searchType[nSearchTypeSel].pFormat, *(float*)m_pSearchMinBuf);
			}
			if (ENUM_SEARCH_DOUBLE == enumSearchType)
			{
				strTmp.Format(searchType[nSearchTypeSel].pFormat, *(double*)m_pSearchMinBuf);
			}
			if (ENUM_SEARCH_STRING == enumSearchType)
			{
				if (FALSE == m_btnUnicode.GetCheck())
				{
					m_pSearchMinBuf[m_nSearchSize-1] = 0;
					strTmp.Format("%s", m_pSearchMinBuf);
				}
				else
				{
					m_pSearchMinBuf[m_nSearchSize-1] = 0;
					m_pSearchMinBuf[m_nSearchSize-2] = 0;
					strTmp = (LPWSTR)m_pSearchMinBuf;
				}
			}
		}
		m_lstCtrlResult.SetItemText(i, 1, strTmp);

		((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize = m_nSearchSize;
		memcpy(((SEARCH_RESULT*)m_aryResult.GetAt(i))->pValue,
			m_pSearchMinBuf, m_nSearchSize);
	}
}

void CModifyMemoryDlg::OnButtonAdd() 
{
	UpdateData(TRUE);
	DWORD dwAddress = 0;
	sscanf(m_strAddress.GetBuffer(m_strAddress.GetLength()), "%x", &dwAddress); 
	m_strAddress.ReleaseBuffer();

	if (0 == dwAddress)
	{
		return ;
	}
	
	for (int i = 0; i < m_aryResult.GetSize(); i++)
	{
		if (dwAddress < ((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress)
		{
			break;
		}
		else if (dwAddress == ((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress)
		{
			return ;
		}
	}

	CString strTmp;
	strTmp.Format("0x%08x", dwAddress);
	m_lstCtrlResult.InsertItem(i, strTmp);

	SEARCH_RESULT *pSearchResult = new SEARCH_RESULT();
	pSearchResult->dwAddress = dwAddress;
	pSearchResult->nValueSize = 0;
	m_aryResult.InsertAt(i, pSearchResult);
	
	m_btnCancelSelect.EnableWindow(TRUE);
	m_btnModifyNumber.EnableWindow(TRUE);
	m_btnSelectAll.EnableWindow(TRUE);
	m_btnResultSearch.EnableWindow(TRUE);
	m_btnRefresh.EnableWindow(TRUE);
	m_btnExportSelect.EnableWindow(TRUE);
}

BOOL CModifyMemoryDlg::OpenThread()
{
	if (NULL != m_hProcess)
	{
		CloseHandle(m_hProcess);
		m_hProcess = NULL;
	}

	CSelectProcessDlg dlgSelectProcesses;
	if (IDCANCEL == dlgSelectProcesses.DoModal())
	{
		return FALSE;
	}
	
	m_dwProcessID = dlgSelectProcesses.m_dwSelectedProcessID;
	m_strTitle = "ModifyMemory - " + dlgSelectProcesses.m_strSelectedProcessName;
	SetWindowText(m_strTitle);
	
	m_hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, m_dwProcessID);

	return TRUE;
}

void CModifyMemoryDlg::OnButtonReselect() 
{	
	CSelectProcessDlg dlgSelectProcesses;
	if (IDCANCEL == dlgSelectProcesses.DoModal())
	{
		return ;
	}

	if (NULL != m_hProcess)
	{
		CloseHandle(m_hProcess);
		m_hProcess = NULL;
	}
	
	m_dwProcessID = dlgSelectProcesses.m_dwSelectedProcessID;
	SetWindowText("ModifyMemory - " + dlgSelectProcesses.m_strSelectedProcessName);
	
	m_hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, m_dwProcessID);
}

BOOL CModifyMemoryDlg::PreTranslateMessage(MSG*   pMsg)   
{ 
	if (WM_KEYDOWN == pMsg-> message) 
	{ 
		if(VK_ESCAPE == pMsg->wParam || VK_RETURN == pMsg->wParam) 
		{ 
			return TRUE; 
		} 
	} 
	return CDialog::PreTranslateMessage(pMsg); 
}

void CModifyMemoryDlg::OnButtonExportSelect() 
{
	CString strTxt;
	CString strTmp;
	int nCheckCount = 0;
	for (int i = 0; i < m_lstCtrlResult.GetItemCount(); i++)
	{
		if( FALSE != m_lstCtrlResult.GetCheck(i))
		{
			nCheckCount++;
			strTmp.Format("0x%08x", ((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress);
			strTxt += strTmp + "\n";
		}
	}

	if (0 == nCheckCount)
	{
		AfxMessageBox("ûѡҪڴַ!");
		return ;
	}

	CFileDialog dlgFile(FALSE, "txt", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
		"ıĵ(*.txt)|*.txt|ļ(*.*)|*.*||");
	if (IDCANCEL == dlgFile.DoModal())
	{
		return ;
	}

	CStdioFile file(dlgFile.GetPathName(), 
		CFile::modeNoTruncate | CFile::modeCreate | CFile::modeWrite);
	file.SeekToEnd();
	file.WriteString(strTxt);
	file.Close();
}

void CModifyMemoryDlg::OnButtonInportFile() 
{
	CFileDialog dlgFile(TRUE, "txt", NULL, 
		OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
		"ıĵ(*.txt)|*.txt|ļ(*.*)|*.*||");
	if (IDCANCEL == dlgFile.DoModal())
	{
		return ;
	}

	CString strAddress;
	DWORD dwAddress;
	int i = 0;
	CStdioFile file(dlgFile.GetPathName(), CFile::modeRead );
	while (FALSE != file.ReadString(strAddress))
	{
		strAddress = strAddress.Left(10);
		sscanf(strAddress.GetBuffer(strAddress.GetLength()), "%x", &dwAddress); 
		strAddress.ReleaseBuffer();

		for (i = 0; i < m_aryResult.GetSize(); i++)
		{
			if (dwAddress < ((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress)
			{
				break ;
			}
			else if (dwAddress == ((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress)
			{
				break ;
			}
		}

		if (i != m_aryResult.GetSize() 
			&& dwAddress == ((SEARCH_RESULT*)m_aryResult.GetAt(i))->dwAddress)
		{
			continue ;
		}

		strAddress.Format("0x%08x", dwAddress);
		m_lstCtrlResult.InsertItem(i, strAddress);

		SEARCH_RESULT *pSearchResult = new SEARCH_RESULT();
		pSearchResult->dwAddress = dwAddress;
		pSearchResult->nValueSize = 0;
		m_aryResult.InsertAt(i, pSearchResult);
	}
	
	if (0 < m_aryResult.GetSize())
	{
		m_btnCancelSelect.EnableWindow(TRUE);
		m_btnModifyNumber.EnableWindow(TRUE);
		m_btnSelectAll.EnableWindow(TRUE);
		m_btnResultSearch.EnableWindow(TRUE);
		m_btnRefresh.EnableWindow(TRUE);
		m_btnExportSelect.EnableWindow(TRUE);
	}
}

void CModifyMemoryDlg::OnSelchangeComboSearchMode() 
{
	RefreshSearchEdit();
}

void CModifyMemoryDlg::OnSelchangeComboSearchType()
{
	RefreshSearchEdit();
}

void CModifyMemoryDlg::RefreshSearchEdit()
{
	ENUM_SEARCH_TYPE enumSearchType = 
		searchType[m_comboxSearchType.GetCurSel()].enumType;
	ENUM_SEARCH_MODE enumSearchMode = 
		searchMode[m_comboxSearchMode.GetCurSel()].enumMode;
	
	GetDlgItem(IDC_STATIC_VALUE)->ShowWindow(enumSearchMode != ENUM_SEARCH_INCREASE
		&& enumSearchMode != ENUM_SEARCH_DECREASE 
		&& enumSearchMode != ENUM_SEARCH_CHANGE);
	
	GetDlgItem(IDC_EDIT_SEARCH_MIN_VALUE)->ShowWindow(enumSearchMode != ENUM_SEARCH_INCREASE
		&& enumSearchMode != ENUM_SEARCH_DECREASE 
		&& enumSearchMode != ENUM_SEARCH_CHANGE);
	
	GetDlgItem(IDC_STATIC_TO)->ShowWindow(enumSearchMode == ENUM_SEARCH_RANGE
		&& enumSearchType != ENUM_SEARCH_STRING);
	
	GetDlgItem(IDC_EDIT_SEARCH_MAX_VALUE)->ShowWindow(enumSearchMode == ENUM_SEARCH_RANGE
		&& enumSearchType != ENUM_SEARCH_STRING);
	
	m_btnUnicode.ShowWindow(enumSearchType == ENUM_SEARCH_STRING);
}

BOOL CModifyMemoryDlg::CanFirstSearch()
{
	int nSearchTypeSel = m_comboxSearchType.GetCurSel();
	int nSearchModeSel = m_comboxSearchMode.GetCurSel();

	ENUM_SEARCH_TYPE enumSearchType = searchType[nSearchTypeSel].enumType;
	ENUM_SEARCH_MODE enumSearchMode = searchMode[nSearchModeSel].enumMode;

	if (ENUM_SEARCH_INCREASE == enumSearchMode
		|| ENUM_SEARCH_DECREASE == enumSearchMode
		|| ENUM_SEARCH_CHANGE == enumSearchMode)
	{
		AfxMessageBox("ģʽ");
		return FALSE;
	}

	if (ENUM_SEARCH_STRING == enumSearchType
		&& ENUM_SEARCH_EQU != enumSearchMode)
	{
		AfxMessageBox("ַڴģʽ");
		return FALSE;
	}
	
	// ı
	if (ENUM_SEARCH_STRING != enumSearchType)
	{
		m_nSearchSize = searchType[nSearchTypeSel].nSize;

		if (m_nSearchSize > m_nMinBufSize)
		{
			delete [] m_pSearchMinBuf;
			m_nMinBufSize = m_nSearchSize;
			m_pSearchMinBuf = new BYTE[m_nMinBufSize];
		}
		sscanf(m_strSearchMin, searchType[nSearchTypeSel].pFormat, m_pSearchMinBuf);

		// Χ
		if (ENUM_SEARCH_RANGE == enumSearchMode)
		{
			if (m_nSearchSize > m_nMaxBufSize)
			{
				delete [] m_pSearchMaxBuf;
				m_nMaxBufSize = m_nSearchSize;
				m_pSearchMaxBuf = new BYTE[m_nMaxBufSize];
			}
			sscanf(m_strSearchMax, searchType[nSearchTypeSel].pFormat, m_pSearchMaxBuf);
		}
	}
	else
	{
		// ıUNICODE
		if (FALSE != m_btnUnicode.GetCheck())
		{
			USES_CONVERSION ;   
			LPWSTR lpwSearchString = A2W(m_strSearchMin);
			m_nSearchSize = (lstrlenW(lpwSearchString) + 1) * 2;

			if (m_nSearchSize > m_nMinBufSize)
			{
				delete [] m_pSearchMinBuf;
				m_nMinBufSize = m_nSearchSize;
				m_pSearchMinBuf = new BYTE[m_nMinBufSize];
			}

			memcpy(m_pSearchMinBuf, lpwSearchString, m_nMinBufSize);
		}
		else
		{
			m_nSearchSize = m_strSearchMin.GetLength() + 1;
			if (m_nSearchSize > m_nMinBufSize)
			{
				delete [] m_pSearchMinBuf;
				m_nMinBufSize = m_nSearchSize;
				m_pSearchMinBuf = new BYTE[m_nMinBufSize];
			}
			sscanf(m_strSearchMin, searchType[nSearchTypeSel].pFormat, m_pSearchMinBuf);
		}
	}

	m_pSearchFunc = searchMode[nSearchModeSel].pSearchFunc;
	
	return TRUE;
}

BOOL CModifyMemoryDlg::CanResultSearch()
{
	int nSearchTypeSel = m_comboxSearchType.GetCurSel();
	int nSearchModeSel = m_comboxSearchMode.GetCurSel();
	
	ENUM_SEARCH_TYPE enumSearchType = searchType[nSearchTypeSel].enumType;
	ENUM_SEARCH_MODE enumSearchMode = searchMode[nSearchModeSel].enumMode;
	
	if (ENUM_SEARCH_STRING == enumSearchType 
		&& ENUM_SEARCH_EQU != enumSearchMode 
		&& ENUM_SEARCH_CHANGE != enumSearchMode)
	{
		AfxMessageBox("ַڴģʽ");
		return FALSE;
	}

	for (int i = 0; i < m_aryResult.GetSize(); i++)
	{
		if (0 == ((SEARCH_RESULT*)m_aryResult.GetAt(i))->nValueSize)
		{
			break;
		}
	}
	if (m_aryResult.GetSize() != i && 
		(enumSearchMode == ENUM_SEARCH_INCREASE
		|| enumSearchMode == ENUM_SEARCH_DECREASE
		|| enumSearchMode == ENUM_SEARCH_CHANGE))
	{
		AfxMessageBox("ʽ뱣ַ֤беַ");
		return FALSE;
	}
	
	// ı
	if (ENUM_SEARCH_STRING != enumSearchType)
	{
		m_nSearchSize = searchType[nSearchTypeSel].nSize;
		
		if (m_nSearchSize > m_nMinBufSize)
		{
			delete [] m_pSearchMinBuf;
			m_nMinBufSize = m_nSearchSize;
			m_pSearchMinBuf = new BYTE[m_nMinBufSize];
		}
		sscanf(m_strSearchMin, searchType[nSearchTypeSel].pFormat, m_pSearchMinBuf);
		
		// Χ
		if (ENUM_SEARCH_RANGE == enumSearchMode)
		{
			if (m_nSearchSize > m_nMaxBufSize)
			{
				delete [] m_pSearchMaxBuf;
				m_nMaxBufSize = m_nSearchSize;
				m_pSearchMaxBuf = new BYTE[m_nMaxBufSize];
			}
			sscanf(m_strSearchMax, searchType[nSearchTypeSel].pFormat, m_pSearchMaxBuf);
		}
	}
	else
	{
		// ıUNICODE
		if (FALSE != m_btnUnicode.GetCheck())
		{
			USES_CONVERSION ;   
			LPWSTR lpwSearchString = A2W(m_strSearchMin);
			m_nSearchSize = (lstrlenW(lpwSearchString) + 1) * 2;
			
			if (m_nSearchSize > m_nMinBufSize)
			{
				delete [] m_pSearchMinBuf;
				m_nMinBufSize = m_nSearchSize;
				m_pSearchMinBuf = new BYTE[m_nMinBufSize];
			}
			
			memcpy(m_pSearchMinBuf, lpwSearchString, m_nMinBufSize);
		}
		else
		{
			m_nSearchSize = m_strSearchMin.GetLength() + 1;
			if (m_nSearchSize > m_nMinBufSize)
			{
				delete [] m_pSearchMinBuf;
				m_nMinBufSize = m_nSearchSize;
				m_pSearchMinBuf = new BYTE[m_nMinBufSize];
			}
			sscanf(m_strSearchMin, searchType[nSearchTypeSel].pFormat, m_pSearchMinBuf);
		}
	}
}
